﻿using System;

namespace _1_OptionalParameters
{
    class Program
    {
        static void Main(string[] args)
        {
            // name is optional
            var greetYou = SayHello();

            Console.WriteLine(greetYou);

            // can provide name if you want
            var greetJoe = SayHello("Joe");

            Console.WriteLine(greetJoe);

            Console.ReadKey();
        }

        // Method with optional parameter
        public static string SayHello(string name = "You")
        {
            return "Hey, " + name + "!";
        }

        //
        // the following shows how optional was simulated before C# 4.0
        //

        //// overload with no parameter
        //public static string SayHello()
        //{
        //    return "Hey, You!";
        //}

        //// overload with normal parameter
        //public static string SayHello(string name)
        //{
        //    return "Hey, " + name + "!";
        //}
    }
}
